/**
 * Copyright (c) 2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.admin.junit;

import java.util.ArrayList;
import java.util.List;

import org.ow2.petals.admin.api.artifact.Artifact;

/**
 * A registry containing the artifact deployed
 * 
 * @author Mathieu CARROLLE - EBM WebSourcing
 * @author Christophe DENEUX - Linagora
 * 
 */
public class ArtifactRegistry {

    /**
     * The JBI artifacts of this artifact registry.
     */
    private final List<Artifact> artifacts = new ArrayList<Artifact>();

    public boolean add(final Artifact a) {
        return this.artifacts.add(a);
    }

    public boolean remove(final Artifact a) {
        boolean removed = false;
        for (final Artifact item : artifacts) {
            if (item.getName().equals(a.getName()) && item.getType().equals(a.getType())) {
                removed = this.artifacts.remove(item);
                break;
            }
        }
        return removed;
    }

    public Artifact[] list() {
        final Artifact[] a = new Artifact[artifacts.size()];
        return artifacts.toArray(a);
    }
    
    public Artifact get(final Artifact a) {
        for (final Artifact artifact : artifacts) {
            if (artifact.equals(a)) {
                return artifact;
            }
        }
        return null;
    }
}
